number.format not working
Target version:

Browser (if web
Description
Maybe it's me, but | am trying to format a number to the given pattern. | have this:

$number.format($field.number_format, $record[$field.column_name])
$field.number_format is "#,###" and $record[$field.column_name] is an integer field.
Is that suppose to work?

| see this:

3,00 %

| suppose this is the default format assigned.

| am basically playing with the possibilities.

History

#1 - 03/21/2011 12:53 PM - Patrick Talbot

Integers are not formatted (or rather they are displayed as plain integers). No one required this before.
If you try with a float, double or decimal this should work.

#2 - 03/21/2011 12:58 PM - Patrick Ruhsert

hm. But they are formatted by the default format, because | see 3,00 $... And | think it is useful to allow that. Image you have a bigger integer and
want to have it as #,###. Then you have a year and don't want it to appear as 2.011.

#3 - 03/21/2011 01:14 PM - Patrick Talbot

Actually bigger integers should appear as-is (2011 will appear as 2011 unless you try to format it).
But you are right, it might be interesting to have them appear with a specific formatting.
Will see how to add that to next version.

#4 - 03/23/2011 05:06 AM - Patrick Talbot
- Status changed from New to Closed

- % Done changed from 0 to 100

Fixed with v1.4.8

#5 - 03/23/2011 10:28 AM - Patrick Ruhsert

| am still having problems with this. Now | have a double and do:
$number.format("#,##0.00", $position.nettowert)

what | get is

3000,00 $

However, if | do
$number.currency($position.nettoverkaufspreis)

| get

1.000,00 €

What seems fixed, by the way, is the open file issue with the latest release.

#6 - 03/23/2011 07:02 PM - Patrick Talbot

Where does the $ comes from???

Do you have used a numberFormat defaultParameter somewhere?

Trying to reproduce and | can't... would you have a sample of this behavior?

#7 - 03/24/2011 09:19 AM - Patrick Ruhsert

In your sample solution, add

context.test = 18687.876867

and in your testTemplate.html add

$number.format("#,##0.00", $test)

What | get is

18687,88 $

without making any further changes to your samples. BTW: This

$number.format("#,##0.00", 99.99)

throws a cantRender exception.

#8 - 03/24/2011 02:03 PM - Patrick Talbot

OK, so the $ is coming from the default format | set in the onLoad() method, that's fine.

Now, what is happening here is that Velocity is choking on the # signs: he tries to interpret #,##0.00 as directive.
There are ways to escape # and $ signs using \ so \# or \$ could be used in a regular text context, but here the problem is that if you use
$number.format("\#,##0.00", $test) then you end up having the extra character in the output, for example \1 8687,88 (because the String is then taken
as-is by the NumberFormat tool)

This is why it isn't working, and why you get a CantRender exception as well (you wouldn't have the exception it if you were to use
$!number.format("#,##0.00", 99.99) but then 99.99 wouldn't be in the output at all).

A solution to this problem is to add a variable in your context which will hold the format, so for example:
context.frmt = "#,##0.00";

context.test = 18687.876867;

Then in the template you will be able to use:

$number.format($frmt, $test)
$number.format($frmt, 99.99)

#9 - 03/24/2011 02:31 PM - Patrick Ruhsert
Sounds logical, everything. | now provide several formats to any report via the context object and it works nicely that way. | think we should mention

this in the FAQs maybe?

#10 - 03/24/2011 02:38 PM - Patrick Talbot

Patrick Ruhsert wrote:

| think we should mention this in the FAQs maybe?

Good point. | will add that. Thanks.
